<?php
add_image_size('ep_attachment_default','185','99999');
add_action("admin_init", "pinterest_meta_box");
function pinterest_meta_box(){
  $types = get_post_types();
  $exclude = array('attachment','revision','nav_menu_item');
  foreach ($types as $type):
  	if (!in_array($type, $exclude))add_meta_box("pinterest_meta", "Pin Button Attraction", "pinterest_options", $type, "advanced", "low");
  endforeach;
}
function pinterest_options() {
	global $post;
	
	$display = get_post_meta($post->ID,'pinterest_display',true);
	$display = (!$display && ep_page_switch()) ? 1 : $display;
	if (!$display) $display = 2;
	
	$nonce= wp_create_nonce('pinterest-nonce'); ?>
    <input type="hidden" name="pinterest-nonce" id="pinterest_noncename_part" value="<?php echo $nonce; ?>" />
    <div class="pinterest-display-wrapper">
        <label for="pinterest-check-<?php echo $post->ID ?>"><?php _e('Pinterest Buttons On or Off for this page?') ?>:</label>
        <?php $options = array(
							   array('value' => 1, 'text' => 'On', 'default' => true),
							   array('value' => 2, 'text' => 'Off', 'default' => false)
							   ); 
		?>
		<select name="pinterest-check" class="ep-select-wrapper" id="pinterest-check-<?php echo $post->ID ?>">
			<?php foreach ($options as $option): ?>
			<option value="<?php echo $option['value'] ?>"<?php if ($option['value'] == $display) echo ' selected="selected"'; ?>><?php _e($option['text']); ?></option>
			<?php endforeach; ?>
		</select>
        <div class="clear"></div>
    </div>
    <p><a href="<?php echo admin_url('admin-ajax.php') ?>?action=ep_display_post_pins&page_id=<?php echo $post->ID ?>&height=700&width=620" title="<?php _e('Edit Post Image Pins') ?>" class="ep-display-post-attachments thickbox button-secondary"><?php _e('Edit Image Pins'); ?></a></p>
	<?php	
}
/* AJAX CALL TO SHOW CURRENT PAGE PINS */
add_action( 'wp_ajax_ep_display_post_pins', 'ep_display_post_pins' );
function ep_display_post_pins() {
	if (!isset($_GET['page_id']) || empty($_GET['page_id'])) exit;
	
	$page_id = $_GET['page_id'];
	$args = array(
		'post_type' => 'attachment',
		'posts_per_page' => -1,
		'post_status' => null,
		'post_parent' => $page_id,
		/*'exclude'     => get_post_thumbnail_id($page_id ) // exclude featured thumbnails */
	);
	
	$thumbnail_id = get_post_thumbnail_id($page_id);
	$attachments = get_posts( $args ); ?>
    <form id="ep-image-pins-form">
		<?php if ($attachments) {
            $count = 0;
            foreach ($attachments as $post): 
                setup_postdata($post);
                $count++;
                $is_thumbnail = ($post->ID == $thumbnail_id) ? true : false; 
                ep_render_image_html($post, $count, $is_thumbnail, $is_thumbnail);
            endforeach;
        }
        wp_reset_postdata(); ?>
        <div class="ep-clear"></div>
        <div class="ep-save-pins-wrapper">
            <input type="button" value="Save Pins" class="button-primary ep-save-image-pins" />
        </div>
    </form>
    <div class="ep-save-results"></div>
	<?php
    exit;
}
/* AJAX CALL TO SHOW CURRENT PAGE PINS */
add_action( 'wp_ajax_ep_save_image_pins', 'ep_save_image_pins' );
function ep_save_image_pins() {
	if (empty($_POST['pins']) || !is_array($_POST['pins'])) return;
	$pins = $_POST['pins'];
	foreach ($pins as $pin) {
		$pin_attr = explode('-',$pin['name']);
		if (!isset($pin_attr[2]) || empty($pin_attr[2])) continue;		
		if (empty($pin['value'])) continue;
		
		$id = (int)$pin_attr[2];
		update_post_meta( $id , 'pinterest', $pin['value']);
	}
	
	_e('<p class="description">The image pins were saved.</p>');
	exit;
}
function ep_render_image_html($post = '', $count = 0, $is_thumbnail = false) {
	if (empty($post)) return;
	$pinned = get_post_meta($post->ID,'pinterest', true);
	
	$check1 = ($pinned == 1) ? "checked = 'checked'" : "";
	$check2 = ($pinned == 2 || !$pinned) ? "checked = 'checked'" : "";
	?>
    <div class="ep-attachment-wrapper<?php if ($count % 3 == 0) echo ' ep-no-margin-right'; ?>">
    	<div class="ep-attachment-image">
        	<?php echo wp_get_attachment_image( $post->ID, 'ep_attachment_default' ); ?>
        </div>
        <div class="ep-label-wrapper">
            <label for="pin-label-yes-<?php echo $post->ID ?>">Yes </label><input type="radio" id="pin-label-yes-<?php echo $post->ID ?>" name="pin-label-<?php echo $post->ID ?>" value="1" <?php echo $check1 ?> />&nbsp;&nbsp;&nbsp;
            <label for="pin-label-no-<?php echo $post->ID ?>">No </label><input type="radio" id="pin-label-no-<?php echo $post->ID ?>" name="pin-label-<?php echo $post->ID ?>" value="2" <?php echo $check2; ?> />
            <?php if ($is_thumbnail) echo '<div class="ep-featured-image-alert">Featured Image</div>'; ?>
        </div>
    </div>
    
    <?php  if ($count % 3 == 0): ?><div class="ep-clear"></div><?php endif; ?>
    <?php	
}
add_action('save_post', 'save_pinterest_details');
function save_pinterest_details(){
	global $post;
	
	// verify this came from our editing screen and with proper authorization, 
	// because save_post can be triggered at other times
	if ( !wp_verify_nonce( $_POST['pinterest-nonce'], 'pinterest-nonce' )) {
		return $post->ID;
	 }
	 // verify if this is an auto save routine. 
	 // If our form has not been submitted, we dont want to do anything
	 if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE )
		return $post->ID;
			
	  // Check permissions
	   if ( (('post' == $_POST['post_type']) || ('page' == $_POST['post_type'])) && ( !current_user_can( 'edit_themes', $post->ID ) ) ) {
		 return $post->ID;
	  }
	  
	  update_post_meta($post->ID,'pinterest_display',$_POST['pinterest-check']);
}
?>