<?php

class Pinterest {

    public function pinterest_frontend_css_js() {
        $deps = array();
        $m_deps = array('load_pinterest', 'ep_custom');

        $load_jquery = ep_jquery();
        if ($load_jquery) {
            wp_enqueue_script('jquery');
            $deps = array('jquery');
            $m_deps = array('jquery', 'load_pinterest', 'ep_custom');
        }
        wp_register_script('load_pinterest', E_URL . '/assets/js/load-pinterest.js', array(), '', true);
        wp_enqueue_script('load_pinterest');
        wp_register_script('ep_custom', E_URL . '/assets/js/easy-pinning.js', $deps, '', true);
        wp_enqueue_script('ep_custom');

        $loader = ep_performance();
        wp_localize_script('ep_custom', 'trigger', array('after_load' => $loader));

        wp_enqueue_style('pinterest_css', E_URL . '/assets/css/pin-style.css');
        $display_mouseover = get_query_var('ep_display_mouseover');
        if ($display_mouseover == 'show-mouseover'):
            wp_register_script('ep_custom_mouseover', E_URL . '/assets/js/easy-pinning-mouseover.js', $m_deps, '', true);
            wp_enqueue_script('ep_custom_mouseover');
            wp_localize_script('ep_custom_mouseover', 'trigger', array('after_load' => $loader));
        endif;
    }

    public function add_pin_image($args = Array()) {
        global $post;

        if (!isset($args['media']) || empty($args['media']))
            return false;
        if (!isset($args['url']) || empty($args['url']))
            return false;
        if (!isset($args['description']) || empty($args['description']))
            $args['description'] = '';
        $layout = (!isset($args['layout']) || empty($args['layout'])) ? ep_pin_layout() : $args['layout'];

        $button = '<span class="pin-button-container pin-button-container-' . $layout . '"><a href="http://pinterest.com/pin/create/button/?url=' . urlencode($args['url']) . '&media=' . urlencode($args['media']) . '&description=' . urlencode($args['description']) . '" class="pin-it-button" count-layout="' . $layout . '"><img border="0" src="//assets.pinterest.com/images/PinExt.png" title="Pin It" /></a></span>';

        return $button;
    }

    public function add_pin_button($display_username = '', $username = '') {
        if (empty($display_username) || empty($username))
            return false;

        $button = '<span class="pin-follow-button"><a href="http://pinterest.com/' . $username . '/"><img src="http://passets-cdn.pinterest.com/images/about/buttons/follow-me-on-pinterest-button.png" width="169" height="28" alt="Follow Me on Pinterest" /></a></span>';
        return $button;
    }

}

?>